/*
  $VER: AWebLinks 1.1 (30.11.96) by gabriele@favrin.net
*/

signal ON syntax
options results
options failat 99

parse SOURCE prog_type result_flag called resolved ext host .

file    = 'AWeb.links'
scr   = ''
nl      = '0a'x
req_title= ' 'host' - Links 1.1 by gabriele@favrin.net'
req_body = 'Fastlinks:'||nl||nl
req_gad  = ''
req_cmd1 = '_Add|_Del|_Cancel'
req_def = 'rtez_defaultresponse='
library = 'rexxreqtools.library'
htmlerr = '<html><title>Missing library!</title><h2>AWeb Links requires <a href="http://ftp.netnet.net/pub/aminet/util/rexx/RexxReqTools.lha">rexxreqtools.library (65k, lha)</a><br>Shift-click on the name to download it from Aminet (at netnet.net).</h2></html>'
htmlfile = 'T:AwebLink-temp'
maxlinks = 10
new   = maxlinks+1
opt   = 0
ct      = 0


If host == 'REXX' then do
  ports=SHOW('P')
  parse VAR ports dummy 'AWEB.' portnr .
  address value 'AWEB.'||portnr

  'Get ACTIVEPORT'
  rhost=result
end
else
  rhost=host

If ~Show('L', library) then
  If ~Exists('libs:'||library) then do
    Call showhtml()
    exit(20)
  end
  else
    Call addlib(library, 0, -30, 0) then


'get screen'
scr='rt_pubscrname='result

Call loadfastlinks()

If ct == 0 then do
  req_body=req_body||'(no fastlinks)'||nl
  req_def_opt=3
end
else
  req_def_opt=1

call rtezrequest(req_body, req_gad''req_cmd1, req_title, scr req_def req_def_opt, 'opt')

select
  when opt == 0 then exit(0)
  when opt == ct+1 then call addlink()
  when opt == ct+2 then call dellink()

  otherwise 'open 'url.opt 'RELOAD'
end
exit(0)


/* Options */

addlink:
  'get url'
  url.new=result

  flag=checkifpresent()

  If flag ~= 0 then do
    'get title'
    name.flag=result

    Call savefastlinks(0)
  end
  else do
    If ct == maxlinks then do
      Call showmsg(1)
      exit(20)
    end
    else do
      ct=ct+1

      url.ct=url.new

      'get title'
      name.ct=result

      Call savefastlinks(0)
    end
  end
  return


dellink:
  If ct == 0 & url.1 == "" then do
    Call showmsg(2)
    exit(20)
  end
  opt=0

  Call rtezrequest(req_body||nl'Choose item to DELETE.', req_gad'_Cancel', req_title, scr req_def ct+1, 'opt')

  If opt ~= 0 then
    Call savefastlinks(opt)

  return


/* Utilities */

showmsg:
  parse ARG err

  select
    when err == 1 then req_err='There are already 'maxlinks' fastlinks...'
    when err == 2 then req_err='There aren''t fastlinks to delete...'
    when err == 3 then req_err='Can''t save fastlinks to disk...'

    otherwise req_err='Error'
  end

  Call rtezrequest(req_err, 'Sigh', req_title, scr, '')
  return


showhtml:
  If Open(fp, htmlfile, 'W') then do
    Call WriteLN(fp, htmlerr)
    Call Close(fp)

    'Open file://localhost/'||htmlfile||' RELOAD'
  end
  return


checkifpresent:
  flag=0

  do a=1 for ct
    If url.a == url.new then flag=a
  end
  return flag


savefastlinks:
  parse arg skip

  If Open(fp, file, 'W') then do
    do a=1 for ct
      If a ~= skip then do
        Call WriteLN(fp, url.a)
        Call WriteLN(fp, name.a)
      end
    end
    Call Close(fp)
  end
  else do
    Call showmsg(3)
    exit(20)
  end
  return


loadfastlinks:
  If Open(fp, file) then do
    do while ~(EOF(fp)) & ct <= maxlinks
      ct=ct+1
      If ct == 10 then
        num=0
      else
        num=ct

      url.ct  = ReadLN(fp)
      name.ct = ReadLN(fp)

      If url.ct ~== "" then do
        req_body=req_body||num||". "||name.ct||nl
        req_gad=req_gad||'_'||num||'|'
      end
    end
    Call Close(fp)
    ct=ct-1
  end
  return
